from collections import OrderedDict

from cs224r.critics.bootstrapped_continuous_critic import \
    BootstrappedContinuousCritic
from cs224r.infrastructure.replay_buffer import ReplayBuffer
from cs224r.infrastructure.utils import *
from cs224r.policies.MLP_policy import MLPPolicyAC
from .base_agent import BaseAgent


class ACAgent(BaseAgent):
    def __init__(self, env, agent_params):
        super(ACAgent, self).__init__()

        self.env = env
        self.agent_params = agent_params

        self.gamma = self.agent_params['gamma']
        self.standardize_advantages = self.agent_params['standardize_advantages']

        self.actor = MLPPolicyAC(
            self.agent_params['ac_dim'],
            self.agent_params['ob_dim'],
            self.agent_params['n_layers'],
            self.agent_params['size'],
            self.agent_params['discrete'],
            self.agent_params['learning_rate'],
        )
        self.critic = BootstrappedContinuousCritic(self.agent_params)

        self.replay_buffer = ReplayBuffer()

    def train(self, ob_no, ac_na, re_n, next_ob_no, terminal_n):
        raise NotImplementedError
        # Not needed for this homework

    ####################################
    ####################################

    def estimate_advantage(self, ob_no, next_ob_no, re_n, terminal_n):
        raise NotImplementedError
        # Not needed for this homework

    ####################################
    ####################################
